package data;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

public class TestRecord {	
	public TestRecord(String name){
		testerName = name;
		recordTable = new Hashtable<String, LinkedList<Long>>();
	}
	
	public String getTesterName(){
		return testerName;
	}
	
	/**
	 * Adds data to the record table
	 * @param charTyped character or word typed by user
	 * @param time time taken to type the character or word by user
	 */
	public void addData(String input, long time){
		LinkedList<Long> l = recordTable.get(input);
		if(l == null){
			l = new LinkedList<Long>();
		}
		l.add(new Long(time));
		recordTable.put(input, l);
		inputLine += input;
	}
	
	public void outputToFile(){
		long currentTime = System.currentTimeMillis();
		String filename = currentTime+"_"+testerName+".txt";
		File f = new File("user_record/"+filename);
		
		String content = getContent(currentTime);
		
		try {
			f.createNewFile();
			
			FileWriter fw = new FileWriter(f);
			fw.write(content);
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		System.out.println("Record exported to: "+filename);
	}
	
	private String getContent(long currentTime){
		String content = new String();
		Date d = new Date(currentTime);
		content = d.toString()+"\n";
		
		for(String key : recordTable.keySet()){
			content += key + "\t";
			Object[] timeList = recordTable.get(key).toArray();
			for(Object o : timeList){
				content += o + "\t"; 
			}
			content += "\n";
		}
		content += inputLine;
		return content;
	}
	
	private String testerName;
	private String inputLine = "";
	public Hashtable<String, LinkedList<Long>> recordTable; 
}
