package util;

import java.awt.Frame;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
/** 
 * This is the application dialog for selecting the translation rule XML file
 * @author Jason. Park
 * @author Ki-Hyun. Sung
 * @author Edmund. Zurita
 * */
public class FileChooser {
	
	public FileChooser(){}
	public static File choose(){
		JFileChooser select_item = new JFileChooser("./rules/");

		select_item.setDialogTitle("Open A File");
		select_item.setFileFilter(new TranslationRuleFileFilter());
		int choice = select_item.showOpenDialog(new Frame());
		if(choice != 0)
			return null;
		File f = select_item.getSelectedFile();
		return f;
	}
}

/** 
 * Filters files so only valid files are displayed in the File Chooser dialog
 * @author Jason. Park
 * @author Ki-Hyun. Sung
 * @author Edmund. Zurita
 * */
class TranslationRuleFileFilter extends FileFilter{
	/**
	 * Default constructor.  It does nothing.
	 */
	public TranslationRuleFileFilter(){
	}
	
    public static int getSuffixNumber(File f) {
        String fname = f.getName();
        for(int i = 0; i < suffixes.length; i++)
            if(fname.endsWith(suffixes[i]))
                return i;

        return -1;
    }

    /**
     * List of suffixes that will be accepted
     */
    public static final String suffixes[] = {
    	//Stands for MIDITranslator User Configuration
        ".xml" 
    };
    
    public boolean accept(File f){
        if(f.isDirectory())
            return true;
        return getSuffixNumber(f) >= 0;
    }

    public String getDescription() {
        return "MIDITranslator User Configuration (XML)";
    }
}
